/***************************************************************************
                          ksplashinstaller.cpp  -  description
                             -------------------
    begin                : Wed Apr 24 17:41:46 IST 2002
    copyright            : (C) 2002 by Balaji Srinivasan
    email                : vinylrecord@yahoo.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <qapplication.h>
#include <qpushbutton.h>
#include <qhbox.h>
#include <qpixmap.h>
#include <qstringlist.h>
#include <qlabel.h>
#include <qdir.h>
#include <qcombobox.h>
#include <qlistbox.h>
#include <qfont.h>
#include <qinputdialog.h>
#include <qfile.h>
#include <qmessagebox.h>
#include <qstringlist.h>


#include <qfiledialog.h>
#include <kfiledialog.h>

#include <kapplication.h>
#include <klocale.h>

#include <stdlib.h>
#include <unistd.h>

#include "ksplashinstaller.h"


QLabel *lblTop, *lblActive, *lblBottom;
QLabel *lblCaption;

QComboBox *cboSplash;

//const QString INSTALL_PATH = QDir::homeDirPath() + "/TestSplashInstaller/";
const QString INSTALL_PATH = QDir::homeDirPath() + "/.KSplashInstaller/";
const QString KSPLASH_PATH = QDir::homeDirPath() + "/.kde/share/apps/ksplash/pics/";
const QString TMP_PATH = QDir::homeDirPath() + "/.kde/share/apps/ksplash/tmp/";

void KSplashInst::dirSelected(const QString &string)
{
	QString cPath = INSTALL_PATH + string;
	printf("\nPath: %s", cPath.latin1());

	lblCaption->setText(string);

	QPixmap picTop;
	picTop.load(cPath + "/splash_top.png");
	lblTop->setPixmap(picTop);

	QPixmap picActive;
	picActive.load(cPath + "/splash_active_bar.png");
	lblActive->setPixmap(picActive);


	QPixmap picBottom;
	picBottom.load(cPath + "/splash_bottom.png");
	lblBottom->setPixmap(picBottom);

}

void KSplashInst::test()
{

	QString *cCommand;
	//Take a backup of the current files

	cCommand = new QString("rm -rf " + TMP_PATH);
	printf("Command: %s\n", cCommand->latin1());
	system(cCommand->latin1());

	cCommand = new QString("cp -rf " + KSPLASH_PATH + " " + TMP_PATH);
	printf("Command: %s\n", cCommand->latin1());
	system(cCommand->latin1());

	apply();

	printf("Splash Start\n");
	system("ksplash --test");
	printf("Splash End\n");
	//Restore

	sleep(2);

	cCommand = new QString("rm -rf " + KSPLASH_PATH);
	printf("Command: %s\n", cCommand->latin1());
	system(cCommand->latin1());

	cCommand = new QString("cp -rf " + TMP_PATH + " " + KSPLASH_PATH);
	printf("Command: %s\n", cCommand->latin1());
	system(cCommand->latin1());


}

void KSplashInst::addFile()
{

/*QString getOpenFileName (
const QString& startDir= QString::null,
const QString& filter= QString::null,
 QWidget *parent= 0,
const QString& caption = QString::null)
 */

//v0.1
	//QString cFileName (QFileDialog::getOpenFileName(QString::null,"SplashScreen Files (*.gz *.zip *.tgz)",this, "Select the Splash to install"));

//v0.1.1
//	QString cFileName = KFileDialog::getOpenFileName("$HOME","SplashScreen Files(*.gz *.zip *.tgz)",this, "Select the Splash to install");

//v0.2 - we want that the previous directory be selected by default
	QString cFileName = KFileDialog::getOpenFileName(QString::null,"SplashScreen Files ( *.zip *.tgz *.gz )",this, "Select the Splash to install");

	if ( cFileName.isEmpty() )
        return;

	printf("File:%s", cFileName.latin1());

	QString cExt;
	int iExtLen = 3;
	cExt = cFileName.right(iExtLen);

	if (cExt == ".gz")
	{
		cExt = "tar.gz";
		iExtLen=6;
	}

	printf("FileType: %s", cExt.latin1());
	QString cSplashName = cFileName.left( cFileName.length() - iExtLen - 1);
	int iPos = cSplashName.findRev("/");
	printf("Splash Name1: %s\n", cSplashName.latin1());
	cSplashName = cSplashName.right(cSplashName.length() - iPos);

	//Remove leading /
	cSplashName = cSplashName.mid(1);

	printf("Splash Name: %s\n", cSplashName.latin1());

	//Prompt for Confirmation
	bool ok = FALSE;

/* QString QInputDialog::getText ( constQString&caption, constQString&label,
 QLineEdit::EchoModemode = QLineEdit::Normal, constQString&text =
 QString::null, bool*ok = 0, QWidget*parent = 0, constchar*name = 0 ) [static] */
  cSplashName = QInputDialog::getText( tr( "Splash Name" ), tr( "Please enter a name for this splash theme (no spaces). " ), QLineEdit::Normal, cSplashName, &ok, this );
  if ( ok && !cSplashName.isEmpty() )
	{

	}

  else
	{
		return;
	}


//	cSplashName = "/" + cSplashName;

	QString cCommand1 = "mkdir " + INSTALL_PATH + cSplashName + "/";
	printf("\n%s\n", cCommand1.latin1());
	system(cCommand1.latin1());

	if (cExt == ".gz" || cExt == "tgz")
	{
		QString cCommand2 = "tar -xvzf " + cFileName + " -C " + INSTALL_PATH + cSplashName + "/ --overwrite";
		printf("\n%s\n", cCommand2.latin1());
		system(cCommand2.latin1());
	}

	if (cExt == "zip")
	{
		QString cCommand2 = "unzip -o " + cFileName + " -d " + INSTALL_PATH + cSplashName + "/";
		printf("\n%s\n", cCommand2.latin1());
		system(cCommand2.latin1());
	}

printf("\nFinished Extraction.\n");

//Do sanity check now, to test if this is a valid splash theme

//QString cCommand1 = ;
QString cPath = INSTALL_PATH + cSplashName;

QStringList * slFiles = new QStringList();
int iNoOfSplashes = getNoOfSplashesInDir(cPath, slFiles);
printf("\nFile ExistsA:%d in %s\n", iNoOfSplashes, cPath.latin1());

if (iNoOfSplashes == 0)
{
	QMessageBox::critical(this, "Invalid file", "This file is not a valid splash file.", QMessageBox::Ok, QMessageBox::NoButton);
	//Delete the copied	theme, which is not _actually_ a theme ;)
	QString cCommand = "rm -rf " + cPath;
	printf("\n%s\n", cCommand.latin1());
	system(cCommand.latin1());

}

if (iNoOfSplashes == 1)
{
	//Since there is only one theme, copy that theme into the parent folder
	cout << "\nhere1\n";

	for ( QStringList::Iterator it = slFiles->begin(); it != slFiles->end(); ++it )
	{
		cout << "\nhere2\n";
		cout << "\nIT:" << *it << ":\n";
		//There should be only one item in this loop
		QString cCommand = "cp " + cPath + "/" + *it + "/* " + cPath;
		printf("\n%s\n", cCommand.latin1());
		system(cCommand.latin1());

	}

}

if (iNoOfSplashes >= 2)
{
	//Since there is only one theme, copy that theme into the parent folder
	cout << "\nhere1a\n";

	for ( QStringList::Iterator it = slFiles->begin(); it != slFiles->end(); ++it )
	{
		cout << "\nhere2a\n";
		cout << "\nIT:" << *it << ":\n";

		QString cNewDir = + INSTALL_PATH + cSplashName + "-" + *it;
		QString cSrcDir = cPath + "/" + *it + "/*";

		//Create each subthemes own directory, and remove the parent.
		QString cCommand = "mkdir " + cNewDir;
		printf("\n%s\n", cCommand.latin1());
		system(cCommand.latin1());

		cCommand = "cp " + cSrcDir + " " + cNewDir;
		printf("\n%s\n", cCommand.latin1());
		system(cCommand.latin1());

	}

	//Remove the parent dir, which is not needed now
	QString cCommand = "rm -rf " + cPath;
	printf("\n%s\n", cCommand.latin1());
	system(cCommand.latin1());

	QMessageBox::information(this, "Multiple Splashes", "More than one splash theme was in this file.\nAll the themes have been installed.", QMessageBox::Ok);

}



loadDir();
}

int KSplashInst::getNoOfSplashesInDir(QString cPath, QStringList *slFiles)
{
//	QString cPath = INSTALL_PATH + cSplashName;
	bool bFileExists;
	bool bFileExistsInSubDir = FALSE;
	int iNoOfSplashes = 0;
	bFileExists = QFile::exists (cPath + "/splash_top.png");

//	QStringList slFiles;

	printf("\nFile Exists:%d in %s\n", bFileExists, cPath.latin1());

	if (bFileExists == TRUE)
	{
	//We currently assume that if there is a theme in the root dir,
	//then there is only one theme.
		iNoOfSplashes = 1;
	}
	else


	{
		//This is not a valid splash file, or the files are stored in a subdirectory
		//So check if file exists in a subdir...

		printf("\nChecking for sub dirs...\n");

		QDir *dir = new QDir(cPath);
		dir->setFilter(QDir::Dirs | QDir::Hidden);

		if (dir->exists() == FALSE)
		{
			//This should never happed
			printf("\nWhoops! This dir doesn't exist, so can't check for subfolders!");
		}
		printf("\nDir exists, now continuing...\n");

		const QFileInfoList *fileList = dir->entryInfoList();
		QFileInfoListIterator fileListIt(*fileList);
		QFileInfo *fileInfo;

		while(fileInfo = fileListIt.current())
		{
			//Remove current and up directories
			if(( (fileInfo->fileName()).compare("..")!=0 ))
			{
				if( (fileInfo->fileName()).compare(".")!=0 )
				{
					//This means that a subfolder DOES exist..
					//Now check if this contains our files.
					bFileExistsInSubDir = QFile::exists (cPath + "/" + fileInfo->fileName() + "/splash_top.png");
					printf("\nChecking Dir %s\n", (cPath + "/" + fileInfo->fileName() + "/splash_top.png").latin1());

					if (bFileExistsInSubDir == TRUE)
					{
						iNoOfSplashes++;
						slFiles->append(fileInfo->fileName());
						printf("\nFile found in subdir: %s \n", (cPath + fileInfo->fileName()).latin1() );
					}


				}
			}
			++fileListIt;
		}

	}
	printf("\nNo. of splashes:%d \n",iNoOfSplashes);
	return iNoOfSplashes;
}



void KSplashInst::addDir()
{
}

void KSplashInst::createKSplashDir()
{
	QString *cCommand;

	cCommand = new QString("mkdir " + QDir::homeDirPath() + "/.kde/share/apps/ksplash/");
	printf("\nCommand1: %s\n", cCommand->latin1());
	system(cCommand->latin1());

	cCommand = new QString("mkdir " + KSPLASH_PATH);
	printf("Command2: %s\n", cCommand->latin1());
	system(cCommand->latin1());

	cCommand = new QString("mkdir " + TMP_PATH);
	printf("Command2: %s\n", cCommand->latin1());
	system(cCommand->latin1());

}


void KSplashInst::apply()
{
	QString *cCommand;
	//Now copy the files to the dir...
	cCommand = new QString("cp -f " + INSTALL_PATH + lblCaption->text() + "/* " + KSPLASH_PATH);
	printf("Commandapply: %s\n", cCommand->latin1());
	system(cCommand->latin1());
}


void KSplashInst::loadDir()
{

	QString cPath = INSTALL_PATH;

	QDir *dir = new QDir(cPath);
	dir->setFilter(QDir::Dirs | QDir::Hidden);

	if (dir->exists() == FALSE)
	{
		QString cMakeDir = "mkdir " + cPath;
		system(cMakeDir.latin1());
		printf("\nCreating default path: %s", cMakeDir.latin1());
	}

	const QFileInfoList *fileList = dir->entryInfoList();
	QFileInfoListIterator fileListIt(*fileList);
	QFileInfo *fileInfo;

	cboSplash->clear();
	cboSplash->insertItem("-Choose a Splash-");


	while(fileInfo = fileListIt.current())
	{
		//Remove current and up directories
		if(( (fileInfo->fileName()).compare("..")!=0 ))
		{
			if( (fileInfo->fileName()).compare(".")!=0 )
			{
				cboSplash->insertItem(fileInfo->fileName());
			}
		}
		++fileListIt;
	}
}



KSplashInst::KSplashInst(QWidget *parent, const char *name):
QVBox(parent,name)
{
  //Definition of helpMenu
  helpMenu = new KHelpMenu(this, KGlobal::instance()->aboutData(), false);

	this->setCaption("K Splash Installer");

	QHBox *mainBox = new QHBox(this);
	mainBox->setSpacing(10);
	mainBox->setMargin(10);

	QVBox *leftBox = new QVBox(mainBox);
//	leftBox->setMinimumWidth(10);

	QVBox *outerBox = new QVBox(mainBox);
	outerBox->setSpacing(10);
	outerBox->setMargin(10);

	QHBox *comboBox = new QHBox(outerBox);
	QLabel *lblInstalledSplash = new QLabel("Installed Splash Screens:", comboBox);
	lblInstalledSplash->setMaximumWidth(150);

	cboSplash = new QComboBox(comboBox);

	QVBox *box = new QVBox(outerBox);
	box->setFixedSize(430,370);
	//box->setSpacing(10);
	box->setMargin(10);
	box->setFrameStyle(WinPanel);
	box->setFrameShadow(Raised);


	QVBox *middleBox = new QVBox(mainBox);

	QVBox *sideBox = new QVBox(mainBox);
	sideBox->setFixedSize(100,400);

//	QVBox *rightBox = new QVBox(mainBox);
//	rightBox->setMinimumWidth(10);



	createKSplashDir();

	loadDir();

	lblCaption = new QLabel(box);

	QFont myFont(QApplication::font());
	myFont.setBold(TRUE);

	lblCaption->setFont(myFont);
	lblCaption->setAlignment(AlignHCenter);

	lblTop = new QLabel(box);


	lblActive = new QLabel(box);
	lblBottom = new QLabel(box);

	box->show();


	QPushButton *addFile = new QPushButton("&Install...", sideBox);
//	QPushButton *addDir = new QPushButton("&Add Splash Directory...", sideBox);
	QPushButton *apply = new QPushButton("&Apply", sideBox);
	QPushButton *test = new QPushButton("&Test", sideBox);

	QPushButton *close = new QPushButton("&Close", sideBox);

  //Definition of about button
  babout = new QPushButton( sideBox, "cmdHelp" );
  //  babout->setGeometry( QRect( 150, 10, 50, 22 ) );
    //babout->setText( tr2i18n( "&Help" ) );
    babout->setText("&Help");

   babout->setAutoRepeat( FALSE );
  babout->setPopup(helpMenu->menu());
//--------------



//	close->setGeometry(62,50,75,30);

	QObject::connect(close, SIGNAL(clicked()), qApp, SLOT(quit()));
	QObject::connect(test, SIGNAL(clicked()), SLOT(test()));


	QObject::connect(apply, SIGNAL(clicked()), SLOT(apply()));
	QObject::connect(addFile, SIGNAL(clicked()), SLOT(addFile()));

//	QObject::connect(addDir, SIGNAL(clicked()), SLOT(addDir()));

	QObject::connect(cboSplash, SIGNAL(highlighted(const QString &)), SLOT(dirSelected(const QString &)) );
	QObject::connect(cboSplash, SIGNAL(activated(const QString &)), SLOT(dirSelected(const QString &)) );

}
